function msfz, vnname, date1, date2, mask=mask, orca=orca, _extra=ex
@common
domdef,0,100000
;-------------------------
case n_params() of
	0:msf=read_ncdf('vomecrty',0,/timestep,_extra=ex,iodir=iodir,/nostruct,/tout) 
	1:begin
	if size(vnname,/type) eq 7 then $
		msf=read_ncdf(vnname,0,/timestep,_extra=ex,iodir=iodir,/nostruct,/tout) $
		else msf=vnname
	end
	2:msf=read_ncdf(vnname,date1,_extra=ex,iodir=iodir,/nostruct,/tout)
	3:msf=read_ncdf(vnname,date1,date2,_extra=ex,iodir=iodir,/nostruct,/tout)
endcase
if n_params() eq 3 then msf=grossemoyenne(msf,'t')
msf=msf*vmask()
if keyword_set(mask) then begin
;      print, 'subdomain: use of mask argument'
     if (size(mask))[0] eq 2 then mask=reform(mask[*]#replicate(1,jpk),jpi,jpj,jpk)
	msf=msf*mask 
endif else mask=1
;print, mask
msf=moyenne(msf,'x',/integration)
msf=1e-6*msf
e3t2d=replicate(1,jpj)#e3t
msf=total(msf*e3t2d,2,/cumulative)
msf=shift(msf,0,1)
; if sub basin, substract the bottom value (equivalent to upward integration)
if keyword_set(mask) then begin
     for k=0, jpk-1 do begin
       for j=0,jpj-1 do begin
	    msf(j,k) = msf(j,k) - msf(j,jpk-1)
	  endfor
	endfor
endif

varname='Meridional Stream Function'
varunit='Sv'
vargrid='W'

if keyword_set(orca) then begin
	case orca of
		2:ixref=51-1
		.5:ixref=204-1
		.25:ixref=408-1
		else:ixref=0
	endcase
	ixref=ixref-ixminmesh
	ixref=ixref+key_shift
	ixref=ixref mod jpi
	if ixref lt 0 then ixref=ixref+jpi
endif else ixref=0
domdef,ixref,ixref,0,jpj-1,0,jpk-1,/index,grille=['T','W']
;terre=where(total(vmask()*mask,1) eq 0)
;if n_elements(valmask) eq 0 then valmask=1e20
;if terre[0] ne -1 then msf[terre]=valmask

;------------------------
return, msf
end