;
; make Wind Stress module
;
FUNCTION make_crtm, file_name, ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, ZMTYP = zmtyp

@common
@com_eg
;
;
; Read U and V
;
   file_nam = strmid(file_name, 0, strlen(file_name)-4)
   vargrid = 'U'
   old_boite = [lon1, lon2, lat1, lat2, prof1, prof2]
   domdef
   ucrt = nc_read(file_nam+'U.nc','vozocrtx', ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2)
   vargrid = 'V'
   vcrt = nc_read(file_nam+'V.nc','vomecrty', ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2)

   wm = norme(ucrt.data, vcrt.data)
   domdef, old_boite

   field = {name: '', data: wm, legend: '', units: '', origin: '', dim: 0}
   
   field.origin = ucrt.origin
   field.dim = ucrt.dim

   return, field
END 
