;
; make work
;
FUNCTION make_work, file_name, ncdf_db,  TIME_1 = time_1,  TIME_2 =  time_2, ZMTYP = zmtyp

@common
@com_eg

; ellipse param

; test 1
;   x0 = 145
;   y0 = 10
;   a1 = 25
;   b1 = 5
;   delta_r = 3

; test 2
;   x0 = 150
;   y0 = 10
;   a1 = 22
;   b1 = 5
;   delta_r = 10

   x0 = 150
   y0 = 10
   a1 = 22
   b1 = 5
   delta_r = 5


   a2 = a1+delta_r/cos(y0*acos(0)*2/180.)
   b2 = b1+delta_r

   work = glamt
   work(*, *) = 0.
   alpha = glamt
   alpha(*, *) = 0.

   A = ((glamu-x0)^2)/(a1^2) + ((gphiu-y0)^2)/b1^2
   A0 = ((glamu-x0)^2)/(a2^2) + ((gphiu-10)^2)/b2^2

   idx = where(A LE 1.) 
   work(idx) = 1.
   idx = where((A0-A) NE 0) 
   alpha(idx) = (A0(idx)-1)*A(idx)/(A0(idx)-A(idx))
   idx = where(A GT 1 AND A0 LE 1)
   work(idx) = alpha(idx)

   VALMASK = 1.e20

   field = {name: '', data: work, legend: '', units: '', origin: '', dim: 0, direc:''}
   
   field.origin = 'make_work'
   field.dim = 2
   field.direc = 'xy'

   return, field
END 
