PRO  pltsc,tab1,tab2, min1, max1, min2, max2, varname2, BOITE = boite, $
           COL1D=col1d,STY1D=sty1d,OV1D=ov1d,THICKN = thickn, FRACTION = fraction, _extra = ex
;
; scatter plot (inspired from plt1d)
;

@common

c_cote = 0

; Rq: on ne reinitialise pas qd on rapelle pltsc
   IF NOT keyword_set(ov1d) THEN reinitplt
   IF NOT keyword_set(thickn) THEN thickn = 2
   IF NOT keyword_set(fraction) THEN fraction = 1.
   ;; reduce data xyzt domain

   oldboite = [lon1, lon2, lat1, lat2, prof1, prof2]
   IF keyword_set(boite) THEN BEGIN 
      IF n_elements(integration3d) EQ 0 THEN integration3d = n_elements(boite) NE 4
      CASE 1 Of
         N_Elements(Boite) Eq 1:bte=[lon1, lon2, lat1, lat2, 0.,boite[0]]
         N_Elements(Boite) Eq 2:bte=[lon1, lon2, lat1, lat2, boite[0],boite[1]]
         N_Elements(Boite) Eq 4:bte=[Boite, prof1, prof2]
         N_Elements(Boite) Eq 5:bte=[Boite[0:3], 0, Boite[4]]
         N_Elements(Boite) Eq 6:bte=Boite
         ELSE: BEGIN 
            ras = report('Mauvaise Definition de Boite') 
            return 
         END 
      ENDCASE 
   ENDIF ELSE  bte=[lon1, lon2, lat1, lat2, prof1, prof2]

   domdef, bte,GRILLE=vargrid

; extract indexes to plot

   indexm = where(tab1 LE valmask/10.)
   tab1 = tab1[indexm]
   tab2 = tab2[indexm]

   npts = (size(indexm))[1]

; deal with  min and max of plot
   IF finite(min1) EQ 0 THEN min1 = min(tab1)
   IF finite(max1) EQ 0 THEN max1 = max(tab1)
   IF finite(min2) EQ 0 THEN min2 = min(tab2)
   IF finite(max2) EQ 0 THEN max2 = max(tab2)
   

; init plot if not overlay
   
   IF NOT keyword_set(ov1d) THEN placedessin, 'yfx', posfenetre, posbar, $
    contour = contour, _extra = ex
   yy = tab1
   xx = tab2

; axis range

   fraction = 0.

   !x.range = [min2-fraction*abs(max2-min2)/5.,max2+fraction*abs(max2-min2)/5.]
   !y.range = [min1-fraction*abs(max1-min1)/5.,max1+fraction*abs(max1-min1)/5.]

   IF (NOT keyword_set(sty1d)) THEN sty1d = 0
   IF (NOT keyword_set(col1d)) THEN col1d = 0
   IF  NOT keyword_set(ov1d) THEN  BEGIN 
      legende, min1, max1, 'yfx', VARNAME2 = varname2, NPTS = npts, _EXTRA = ex 
;
      plot,xx,yy, background = 255, psym = sty1d+1, color=col1d, thick=thickn $
       , title = '', subtitle = '',_extra = ex

      IF n_elements(ex) NE 0 THEN BEGIN 
; pour avoir un cadre de la couleur c_cote et trace une ligne a y=0
         IF (where(tag_names(ex) EQ 'COLOR'))[0] NE -1 THEN ex.COLOR = c_cote
         IF (where(tag_names(ex) EQ 'LINESTYLE'))[0] NE -1 THEN ex.LINESTYLE= 0
      ENDIF
      plot, !x.range, [0, 0],/noerase,color=c_cote, xstyle = 1, ystyle = 1, _extra = ex
; trace une ligne a x=0
      plot, [0, 0],!y.range ,/noerase,color=c_cote, title = '', subtitle = '', _extra = ex
   ENDIF ELSE oplot,xx,yy,color=col1d,psym=sty1d+1,thick=thickn, _extra = ex
;------------------------------------------------------------
;------------------------------------------------------------
; 3eme partie: impression eventuelle
;------------------------------------------------------------
;------------------------------------------------------------
fini:
   domdef, oldboite,GRILLE=vargrid
   terminedessin, _extra = ex
;------------------------------------------------------------
   IF n_elements(key_performance) NE 0 THEN $
    IF key_performance EQ 1 THEN print, 'temps plt1d', systime(1)-tempsun 
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
   return 
END 


