PRO post_LMA_PATT_AM
;
; 1.Declaration des variables
;

u =strarr(1)
xdim = 57
ydim = 16
patt_sum1r = fltarr(xdim, ydim)
patt_sum1i = fltarr(xdim, ydim)
patt_sum2r = fltarr(xdim, ydim)
patt_sum2i = fltarr(xdim, ydim)
patt_win1r = fltarr(xdim, ydim)
patt_win1i = fltarr(xdim, ydim)
patt_win2r = fltarr(xdim, ydim)
patt_win2i = fltarr(xdim, ydim)

;
; 2.Recuperation des donnees sur le fichier binaire
;
directory = 'LMA_in/'
OPENR, 10, directory+'M_PATT_OLR_0'
READF, 10, FORMAT = '(2(A5,I1,A1,I1))', u
FOR j = 0,ydim-1 DO BEGIN 
  FOR i = 0,xdim-1 DO BEGIN 
  READF, 10, FORMAT = '(2E12.5)',re, im
patt_sum1r(i, j) = re 
patt_sum1i(i, j) = im
  ENDFOR 
ENDFOR  
READF, 10, FORMAT = '(2(A5,I1,A1,I1))', u
FOR j = 0,ydim-1 DO BEGIN 
  FOR i = 0,xdim-1 DO BEGIN 
  READF, 10, FORMAT = '(2E12.5)',re, im
patt_sum2r(i, j) = re 
patt_sum2i(i, j) = im
  ENDFOR 
ENDFOR
READF, 10, FORMAT = '(2(A5,I1,A1,I1))', u
FOR j = 0,ydim-1 DO BEGIN 
  FOR i = 0,xdim-1 DO BEGIN 
  READF, 10, FORMAT = '(2E12.5)',re, im
patt_win1r(i, j) = re
patt_win1i(i, j) = im
  ENDFOR 
ENDFOR
READF, 10, FORMAT = '(2(A5,I1,A1,I1))', u
FOR j = 0,ydim-1 DO BEGIN 
  FOR i = 0,xdim-1 DO BEGIN 
  READF, 10, FORMAT = '(2E12.5)',re, im
patt_win2r(i, j) = re
patt_win2i(i, j) = im
  ENDFOR 
ENDFOR

close, 10

OPENR, 20, directory+'DIST_C_OLR_0'
READF, 20, NCMAX
ncmax = fix(ncmax)
selec = intarr(NCMAX)
vari = fltarr(xdim, ydim, NCMAX)
READF, 20, FORMAT = '(A52,9A8)', u
FOR t = 0, NCMAX-1 DO BEGIN
READF, 20, FORMAT = '(2E12.5,12I5)',res1, res2, res3, res4, res5, res6, res7, res8, res9
selec(t) = res8
ENDFOR
close, 20
OPENR, 30, directory+'PATT_OLR0'
FOR ta = 0, NCMAX-1 DO BEGIN 
READF, 30, FORMAT = '(3a14)', u
  FOR j = 0,ydim-1 DO BEGIN 
    FOR i = 0,xdim-1 DO BEGIN 
      READF, 30, FORMAT = '(3E12.5)', re, im, var
      vari(i, j, ta) = var
    ENDFOR
  ENDFOR
ENDFOR
close, 30
selec3d = replicate(1, xdim*ydim)#selec
vari_win = vari[where(selec3d EQ 0.)]
vari_win = reform(vari_win, xdim, ydim, NCMAX-total(selec))
vari_sum = vari[where(selec3d EQ 1.)]
vari_sum =  reform(vari_sum, xdim, ydim,total(selec)) 
var_win = total(vari_win, 3)/(NCMAX-total(selec))
var_sum = total(vari_sum, 3)/(total(selec))
var = total(vari, 3)/NCMAX
; 3.Creation du fichier NCDF qui contier les patterns des modes moyens
;


; Nom
idout = NCDF_CREATE('LMA_out/OLR_AM.T.nc', /CLOBBER)
NCDF_CONTROL, idout, /nofill
; Dimension
xidout = NCDF_DIMDEF(idout, 'x', 80)
yidout = NCDF_DIMDEF(idout, 'y', 25)
tidout = NCDF_DIMDEF(idout, 'record', /unlimited)
; Attributs globaux
id0 = NCDF_VARDEF(idout, 'nav_lon', $
                  [xidout, yidout], /FLOAT)
id1 = NCDF_VARDEF(idout, 'nav_lat', $
                  [xidout, yidout], /FLOAT)
id2 = NCDF_VARDEF(idout, 'AM_win1r',$
                  [xidout, yidout, tidout], /FLOAT)
id3 = NCDF_VARDEF(idout, 'AM_win1i',$
                  [xidout, yidout, tidout], /FLOAT)
id4 = NCDF_VARDEF(idout, 'AM_win2r',$
                  [xidout, yidout, tidout], /FLOAT)
id5 = NCDF_VARDEF(idout, 'AM_win2i',$
                  [xidout, yidout, tidout], /FLOAT)
id6 = NCDF_VARDEF(idout, 'AM_sum1r',$
                  [xidout, yidout, tidout], /FLOAT)
id7 = NCDF_VARDEF(idout, 'AM_sum1i',$
                  [xidout, yidout, tidout], /FLOAT)
id8  = NCDF_VARDEF(idout, 'AM_sum2r',$
                  [xidout, yidout, tidout], /FLOAT)
id9  = NCDF_VARDEF(idout, 'AM_sum2i',$
                  [xidout, yidout, tidout], /FLOAT)
id10 = NCDF_VARDEF(idout,'timecounter', $
                  [tidout], /FLOAT)
id11  = NCDF_VARDEF(idout, 'var_win',$
                  [xidout, yidout, tidout], /FLOAT)
id12  = NCDF_VARDEF(idout, 'var_sum',$
                  [xidout, yidout, tidout], /FLOAT)
id13  = NCDF_VARDEF(idout, 'var',$
                  [xidout, yidout, tidout], /FLOAT)
; Attributs globaux
NCDF_ATTPUT, idout, 'file_name', 'OLR_AM.T.nc', /GLOBAL
NCDF_ATTPUT, idout, 'model_name', 'Outgoing Longwave Radiation Average modes', /GLOBAL
NCDF_ATTPUT, idout, 'sources', 'sur rhodes /workdir/../DONNEES/OLR/DATA', /GLOBAL
; Variable 0
NCDF_ATTPUT, idout, id0, 'units', 'degrees_east'
NCDF_ATTPUT, idout, id0, 'valid_min', 40.
NCDF_ATTPUT, idout, id0, 'valid_max', 237.5
NCDF_ATTPUT, idout, id0, 'grid_step', 2.5
NCDF_ATTPUT, idout, id0, 'long_name', 'longitude'
NCDF_ATTPUT, idout, id0, 'nav_model', 'Default grid'
NCDF_ATTPUT, idout, id0, 'axis', 'YX'
NCDF_ATTPUT, idout, id0, 'associate', 'nav_lat nav_lon'
; Variable 1
NCDF_ATTPUT, idout, id1, 'units', 'degrees_north'
NCDF_ATTPUT, idout, id1, 'valid_min', -30
NCDF_ATTPUT, idout, id1, 'valid_max', 30
NCDF_ATTPUT, idout, id1, 'grid_step', 2.5
NCDF_ATTPUT, idout, id1, 'long_name', 'latitude'
NCDF_ATTPUT, idout, id1, 'nav_model', 'Default grid'
NCDF_ATTPUT, idout, id1, 'axis', 'YX'
NCDF_ATTPUT, idout, id1, 'associate', 'nav_lat nav_lon'
; Variable 2
NCDF_ATTPUT, idout, id2, 'units', 'SI'
NCDF_ATTPUT, idout, id2, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id2, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id2, 'long_name', 'Real part of OLR winter pattern 1'
NCDF_ATTPUT, idout, id2, 'short_name', 'OLR_win1r'
NCDF_ATTPUT, idout, id2, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id2, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id2, 'axis', 'TYX'
NCDF_ATTPUT, idout, id2, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id2, 'missing_values', 655.31
NCDF_ATTPUT, idout, id2, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id2, 'interval__write', 604800.
NCDF_ATTPUT, idout, id2, 'online_operation', 'inst(only(x))'
; Variable 3
NCDF_ATTPUT, idout, id3, 'units', 'SI'
NCDF_ATTPUT, idout, id3, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id3, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id3, 'long_name', 'Imaginary part of OLR winter pattern 1'
NCDF_ATTPUT, idout, id3, 'short_name', 'OLR_win1i'
NCDF_ATTPUT, idout, id3, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id3, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id3, 'axis', 'TYX'
NCDF_ATTPUT, idout, id3, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id3, 'missing_values', 655.31
NCDF_ATTPUT, idout, id3, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id3, 'interval__write', 604800.
NCDF_ATTPUT, idout, id3, 'online_operation', 'inst(only(x))'
; Variable 4
NCDF_ATTPUT, idout, id4, 'units', 'SI'
NCDF_ATTPUT, idout, id4, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id4,  'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id4, 'long_name', 'Real part of OLR winter pattern 2'
NCDF_ATTPUT, idout, id4, 'short_name', 'OLR_win2r'
NCDF_ATTPUT, idout, id4, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id4, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id4, 'axis', 'TYX'
NCDF_ATTPUT, idout, id4, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id4, 'missing_values', 655.31
NCDF_ATTPUT, idout, id4, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id4, 'interval__write', 604800.
NCDF_ATTPUT, idout, id4, 'online_operation', 'inst(only(x))'
; Variable 5
NCDF_ATTPUT, idout, id5, 'units', 'SI'
NCDF_ATTPUT, idout, id5, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id5, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id5, 'long_name', 'Imaginary part of OLR winter pattern 2'
NCDF_ATTPUT, idout, id5, 'short_name', 'OLR_win2i'
NCDF_ATTPUT, idout, id5, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id5, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id5, 'axis', 'TYX'
NCDF_ATTPUT, idout, id5, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id5, 'missing_values', 655.31
NCDF_ATTPUT, idout, id5, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id5, 'interval__write', 604800.
NCDF_ATTPUT, idout, id5, 'online_operation', 'inst(only(x))'
; Variable 6
NCDF_ATTPUT, idout, id6, 'units', 'SI'
NCDF_ATTPUT, idout, id6, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id6, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id6, 'long_name', 'Real part of OLR summer pattern 1'
NCDF_ATTPUT, idout, id6, 'short_name', 'OLR_sum1r'
NCDF_ATTPUT, idout, id6, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id6, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id6, 'axis', 'TYX'
NCDF_ATTPUT, idout, id6, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id6, 'missing_values', 655.31
NCDF_ATTPUT, idout, id6, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id6, 'interval__write', 604800.
NCDF_ATTPUT, idout, id6, 'online_operation', 'inst(only(x))'
; Variable 7
NCDF_ATTPUT, idout, id7, 'units', 'SI'
NCDF_ATTPUT, idout, id7, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id7, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id7, 'long_name', 'Imaginary part of OLR summer pattern 1'
NCDF_ATTPUT, idout, id7, 'short_name', 'OLR_sum1i'
NCDF_ATTPUT, idout, id7, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id7, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id7, 'axis', 'TYX'
NCDF_ATTPUT, idout, id7, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id7, 'missing_values', 655.31
NCDF_ATTPUT, idout, id7, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id7, 'interval__write', 604800.
NCDF_ATTPUT, idout, id7, 'online_operation', 'inst(only(x))'
; Variable 8
NCDF_ATTPUT, idout, id8, 'units', 'SI'
NCDF_ATTPUT, idout, id8, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id8, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id8, 'long_name', 'Real part of OLR summer pattern 2'
NCDF_ATTPUT, idout, id8, 'short_name', 'OLR_sum2r'
NCDF_ATTPUT, idout, id8, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id8, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id8, 'axis', 'TYX'
NCDF_ATTPUT, idout, id8, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id8, 'missing_values', 655.31
NCDF_ATTPUT, idout, id8, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id8, 'interval__write', 604800.
NCDF_ATTPUT, idout, id8, 'online_operation', 'inst(only(x))'
; Variable 9
NCDF_ATTPUT, idout, id9, 'units', 'SI'
NCDF_ATTPUT, idout, id9, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id9, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id9, 'long_name', 'Imaginary part of OLR summer pattern 2'
NCDF_ATTPUT, idout, id9, 'short_name', 'OLR_sum2i'
NCDF_ATTPUT, idout, id9, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id9, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id9, 'axis', 'TYX'
NCDF_ATTPUT, idout, id9, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id9, 'missing_values', 655.31
NCDF_ATTPUT, idout, id9, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id9, 'interval__write', 604800.
NCDF_ATTPUT, idout, id9, 'online_operation', 'inst(only(x))'
; Variable 10
NCDF_ATTPUT, idout, id10, 'units', 'seconds since 01-06-15 00:00:00'
NCDF_ATTPUT, idout, id10, 'calendar', 'Gregorian calendar'
NCDF_ATTPUT, idout, id10, 'title', 'Time'
NCDF_ATTPUT, idout, id10, 'long_name', 'Time axis'
NCDF_ATTPUT, idout, id10, 'time_origin', '01-JUN-15 00:00:00'
; Variable 11
NCDF_ATTPUT, idout, id11, 'units', 'SI'
NCDF_ATTPUT, idout, id11, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id11, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id11, 'long_name', 'Mean winter OLR '
NCDF_ATTPUT, idout, id11, 'short_name', 'OLR_meanwin'
NCDF_ATTPUT, idout, id11, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id11, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id11, 'axis', 'TYX'
NCDF_ATTPUT, idout, id11, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id11, 'missing_values', 655.31
NCDF_ATTPUT, idout, id11, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id11, 'interval__write', 604800.
NCDF_ATTPUT, idout, id11, 'online_operation', 'inst(only(x))'
; Variable 12
NCDF_ATTPUT, idout, id12, 'units', 'SI'
NCDF_ATTPUT, idout, id12, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id12, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id12, 'long_name', 'Mean summer OLR'
NCDF_ATTPUT, idout, id12, 'short_name', 'OLR_meansum'
NCDF_ATTPUT, idout, id12, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id12, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id12, 'axis', 'TYX'
NCDF_ATTPUT, idout, id12, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id12, 'missing_values', 655.31
NCDF_ATTPUT, idout, id12, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id12, 'interval__write', 604800.
NCDF_ATTPUT, idout, id12, 'online_operation', 'inst(only(x))'
; Variable 13
NCDF_ATTPUT, idout, id13, 'units', 'SI'
NCDF_ATTPUT, idout, id13, 'valid_min', -0.00000e+00
NCDF_ATTPUT, idout, id13, 'valid_max', -0.00000e+00
NCDF_ATTPUT, idout, id13, 'long_name', 'Mean summer OLR'
NCDF_ATTPUT, idout, id13, 'short_name', 'OLR_mean'
NCDF_ATTPUT, idout, id13, 'longitude', 'nav_lon'
NCDF_ATTPUT, idout, id13, 'latitude', 'nav_lat'
NCDF_ATTPUT, idout, id13, 'axis', 'TYX'
NCDF_ATTPUT, idout, id13, 'associate', 'time_counter nav_lat nav_lon'
NCDF_ATTPUT, idout, id13, 'missing_values', 655.31
NCDF_ATTPUT, idout, id13, 'interval_operation', 604800.
NCDF_ATTPUT, idout, id13, 'interval__write', 604800.
NCDF_ATTPUT, idout, id13, 'online_operation', 'inst(only(x))'
NCDF_CONTROL, idout, /ENDEF

;
;   Remplissage des variables de grille
;
; Creation de la longitude
lon = 40.+2.5*indgen(80)
lon = lon#replicate(1, 25)
NCDF_VARPUT, idout, id0, lon
; Creation de la latitude
lat = -30.+2.5*indgen(25)
lat = replicate(1, 80)#lat
NCDF_VARPUT, idout, id0, lat
; Creation du temps bidon
temps = 0.
ncdf_varput, idout, id10, temps
; Stockage des donnees
NCDF_VARPUT, idout, id2, patt_win1r
NCDF_VARPUT, idout, id3,- patt_win1i
NCDF_VARPUT, idout, id4, patt_win2r
NCDF_VARPUT, idout, id5,- patt_win2i
NCDF_VARPUT, idout, id6, patt_sum1r
NCDF_VARPUT, idout, id7,- patt_sum1i
NCDF_VARPUT, idout, id8, patt_sum2r
NCDF_VARPUT, idout, id9,- patt_sum2i
NCDF_VARPUT, idout, id11,var_win
NCDF_VARPUT, idout, id12, var_sum
NCDF_VARPUT, idout, id13, var
;
; 3.Fermeture des fichiers
;
NCDF_CLOSE, idout
 return
end

